    let originalOrder = [];
    let isRamSortingEnabled = false;
    let isCpuSortingEnabled = false;
    let isSpacePressed = false;
    let barWidth = 60;
    let barHeight = 10;
    const storedViewMode = localStorage.getItem('viewMode') || 'grid';
    let storedTileOpacity = localStorage.getItem('tileOpacity') || 1;
    let pollingFrequency = localStorage.getItem('pollingFrequency') || 1000;
    let storedStraightEdges = JSON.parse(localStorage.getItem('straightEdges')) || false;
    let storedSortingEnabled = JSON.parse(localStorage.getItem('sortTilesAlphabetically')) || false;
    let storedUsername = localStorage.getItem('username') || 'Demo User';
    let storedPollingFrequency = localStorage.getItem('pollingFrequency') || 1;
    let masterTileColor = localStorage.getItem('masterTileColor') || '#0078d7';
    let storedFontColor = localStorage.getItem('fontColor') || '#ffffff';
    const searchIcon = document.getElementById('search-icon');
    const searchInput = document.getElementById('tile-search');
    const settingsPanel = document.getElementById('settings-panel');
    const avatarElement = document.querySelector('.user-avatar');
    const storedBackgroundImage = localStorage.getItem('backgroundImage');
    const storedBackgroundOpacity = localStorage.getItem('backgroundOpacity') || 1;
    const usernameElement = document.querySelector('.username');
    const sortToggleSpan = document.getElementById('sort-toggle-span');
    const sortToggleCheckbox = document.getElementById('sort-tiles');
    const cornerToggleSpan = document.getElementById('corner-toggle-span');
    const cornerToggleCheckbox = document.getElementById('corner-style');
    const storedNotificationSound = localStorage.getItem('notificationSound');
    let notificationSoundUrl = 'assets/sounds/notification.mp3';
    const listViewButton = document.getElementById('list-view-button');
    const settingsButton = document.getElementById('settings-button');

    const assets = [
        'assets/fonts/OpenSans-Regular.ttf',
        'assets/images/background.png',
        'assets/images/server-almalinux.png',
        'assets/images/server-alpine.png',
        'assets/images/server-arch.png',
        'assets/images/server-aws.png',
        'assets/images/server-azure.png',
        'assets/images/server-centos.png',
        'assets/images/server-debian.png',
        'assets/images/server-deepin.png',
        'assets/images/server-digitalocean.png',
        'assets/images/server-fedoralinux.png',
        'assets/images/server-gentoo.png',
        'assets/images/server-linode.png',
        'assets/images/server-linux.png',
        'assets/images/server-linuxmint.png',
        'assets/images/server-macos.png',
        'assets/images/server-manjarolinux.png',
        'assets/images/server-opensuse.png',
        'assets/images/server-pop!_os.png',
        'assets/images/server-redhat.png',
        'assets/images/server-rockylinux.png',
        'assets/images/server-rpi.png',
        'assets/images/server-tvos.png',
        'assets/images/server-ubuntu.png',
        'assets/images/server-watchos.png',
        'assets/images/server-windows.png'
        ];


    document.addEventListener('DOMContentLoaded', () => {
        const queue = new createjs.LoadQueue(true);
        queue.on("complete", () => {
            setTimeout(launchDashboard, 2500);
        });

        document.getElementById('spinner').style.display = 'block';

        queue.loadManifest([
            { id: "openSansFont", src: "assets/fonts/OpenSans-Regular.ttf" },
            { id: "bgImage", src: "assets/images/background.png" },
            { id: "logo", src: "assets/images/lavishui-logo.png" }
        ]);

        function launchDashboard() {
            document.getElementById('login-box').style.display = 'none';
            document.getElementById('spinner').style.display = 'none';
            document.getElementById('content').style.display = 'block';
    
            if (storedNotificationSound) {
                notificationSoundUrl = storedNotificationSound;
            }
    
            //Toast.initNotificationIcon();
    
            if (storedBackgroundImage) {
                document.body.style.setProperty('--background-image', `url(${storedBackgroundImage})`);
            }
            document.body.style.setProperty('--background-opacity', storedBackgroundOpacity);
    
            document.documentElement.style.setProperty('--tile-background-opacity', storedTileOpacity);
    
            const storedAvatar = localStorage.getItem('userAvatar');
            if (storedAvatar) {
                avatarElement.src = storedAvatar;
            }
    
            if (storedUsername) {
                usernameElement.textContent = storedUsername;
            }
    
            document.getElementById('username-input').value = storedUsername;
            document.getElementById('tile-opacity').value = storedTileOpacity;
            document.getElementById('master-tile-color').value = masterTileColor;
            document.getElementById('corner-style').checked = storedStraightEdges;
            document.getElementById('sort-tiles').checked = storedSortingEnabled;
    
            // Load stored font color on initialization
            applyFontColor(storedFontColor);
            document.getElementById('font-color').value = storedFontColor;
            setInterval(() => {
                createTilesFromAPI('api/stats');
            }, pollingFrequency);
    
            const tileContainer = document.querySelector('.tile-container');
            originalOrder = Array.from(tileContainer.children).map((tile) => ({
                element: tile,
                index: tile.dataset.index
            }));
    
            setTimeout(() => {
                document.getElementById('notification-area').classList.add('slide-down');
                document.getElementById('search-container').classList.add('slide-in');
                document.getElementById('hotkeys').classList.add('slide-up');
                document.getElementById('logo-image').classList.add('slide-up');
            }, 500);
        }
    });